`include "discipline.h"
`include "constants.h"

module Memory_input_gen (in1,in2,Data_out_MAC,clk2);

output [15:0] in1;///HEre
output [15:0] in2;  ///HEre
input [15:0] Data_out_MAC; ///HEre
input clk2;
electrical clk2;
electrical [15:0] in1;//Here
electrical [15:0] in2;//Here
electrical [15:0] Data_out_MAC;//Here

parameter string file_name1 = "/afs/glue.umd.edu/home/glue/c/h/charanas/home/enee719d/skywater_130_enee719d/inputs_11_4.txt";
parameter string file_name2 = "/afs/glue.umd.edu/home/glue/c/h/charanas/home/enee719d/skywater_130_enee719d/data/weights_11_4.txt";
parameter string file_name3 = "/afs/glue.umd.edu/home/glue/c/h/charanas/home/enee719d/skywater_130_enee719d/data/MAC_output.txt";
parameter real tperiod = 1u from (0:inf);
parameter real tdel = 0 from [0:inf);
parameter real trise = 1n;
parameter real tfall = 1n;
parameter real Vhigh =1;
parameter real Vlow =0;
parameter real vlogic_high = 1;
parameter real vlogic_low = 0 ;
parameter real vtrans_clk = 0.5;
real next;
integer bit1;
integer bit2;
integer bit3;
real vout_in1[0:15];
real vout_in2[0:15];
integer file_handle1;
integer file_handle2;
integer file_handle3;
integer ret_val1;
integer ret_val2;
genvar i;
genvar j;

analog begin
@( initial_step ) begin
file_handle1 = $fopen(file_name1, "r");
file_handle2 = $fopen(file_name2, "r");
file_handle3 = $fopen(file_name3, "w");
end


@(cross( V(clk2) - vtrans_clk, +1 )) begin

ret_val1=$fscanf(file_handle1,"%d",bit1);
$strobe("bit1 = %d\n", bit1);
ret_val2=$fscanf(file_handle2,"%d",bit2);
$strobe("bit2 = %d\n", bit2);
for (j = 0; j < 16; j = j + 1) begin
if ((bit1%2)==0) vout_in1[j] =vlogic_low;
else vout_in1[j] =vlogic_high;
bit1=bit1/2;
end
bit1=0;
for (j = 0; j < 16; j = j + 1) begin
if ((bit2%2)==0) vout_in2[j] =vlogic_low;
else vout_in2[j] =vlogic_high;
bit2=bit2/2;
end 
end
bit2=0;
@(cross( V(clk2) - vtrans_clk, -1 )) begin

for (j = 0; j < 16; j = j + 1) begin
if (V(Data_out_MAC[j])>vtrans_clk) bit3 =bit3 + 2**j;
else bit3=bit3;
end
$fwrite(file_handle3,"%d\n",bit3);
//$strobe("bit3 = %d\n", bit3);
bit3=0;
end


for (i = 0; i < 16; i = i + 1) begin
    V(in1[i]) <+ transition(vout_in1[i], tdel, trise, tfall) ;
    V(in2[i]) <+ transition(vout_in2[i], tdel, trise, tfall) ;
end

@(final_step) begin
 $fclose(file_handle1);
 $fclose(file_handle2);
$fclose(file_handle3);
end
end

endmodule


